PROCEDURE Reorg
*	This program will recreate all generic Compound Indexes for all
*	open databases.
*
*	This program assumes the following:
*		All databases that you want indexed are currently open
*		and available for business (this means that they are accessable
*		in a multi-user situation), OR that your error routine
*		will catch problems with such...
*
*		That all indexes are CDX Tags.
*
*		That none of the Tags are UNIQUE
*
*		That you're a deserving boy or girl.
*
*	Written by R.L. Coppedge
*	Copyright 1991 dbF Software Productions
*	By the way, dbF also has:
*	SysTrak		A Computer Hardware/Software Inventory System
*	Flags		A Flatfile Application Gen. for db3,4 and Fox
*	ClasAdz		A Classified/Notice system for Networks
*	FerretPro	A collection of FoxPro tools (like this one)
*	Contact dbF for more information.
*	dbF Software Productions
*	P.O. Box 37194
*	Cleve., Ohio 44137-0194
*	CIS: 72117,165
*	(216)491-4581
*
*	This code may be modified, but leave this original notice up
*	here intact, if ya don't mind.  (Add your own comments about
*	how much better you made it if you like)

PRIVATE I, J, Vw, X, Dbftags
DEFINE WINDOW Ferret FROM 5,50 TO 22,79 DOUBLE
ACTIVATE WINDOW Ferret
@0,2 SAY "dbF Reorg Tool!"
@2,2 SAY "This will reorganize"
@3,2 SAY "all currently open"
@4,2 SAY "database file's CDX"
@5,2 SAY "Tags...do you want"
@6,2 SAY "to continue?"
@7,2 GET choice FUNCTION '* \!\<OK;\?\<Cancel' DEFAULT 1
READ
IF Choice = 1
	Vw = SYS(3)			&&	1st we'll create a view (since all relations
	CREATE VIEW (Vw)	&&	are about to be trashed)
	FOR X=1 TO 25		&&	loop for all areas
		IF !EMPTY(DBF(X))		&&	if there's one here
			SELECT (X)
			USE DBF(X) EXCLUSIVE	&&	open for business
			WAIT "Now Indexing: " + ALIAS(X) +" "+ALLTRIM(STR(RECCOUNT(X))) + ;
			" Records" WINDOW NOWAIT
			SELECT (X)
			DIMENSION dbftags(256,3)
			*	dbftags(X,1) = the Tag name
			*	dbftags(X,2) = the Tag's expression
			*	dbftags(X,3) = the Filter expression in the index
			FOR I = 1 TO 256	&&	Straight (almost) from FoxHelp
				IF EMPTY(tag(I))
					I = I - 1
					IF I > 0	&&	Don't dimension a 0,3 array...silly
						DIMENSION dbftags(I,3)
					ENDIF
					EXIT
				ELSE
					dbftags(I,1) = tag(I)
					dbftags(I,2) = KEY(I)
					dbftags(I,3) = IIF(!EMPTY(SYS(2021,I))," FOR "+SYS(2021,I),"")
				ENDIF
			ENDFOR
			IF I > 0		&&	If there are any Tag's
				DELETE TAG ALL		&&	delete the file
				FOR J = 1 TO I		&&	Loop for all Tags
					INDEX ON &Dbftags(J,2) TAG (Dbftags(J,1)) &Dbftags(J,3)
				ENDFOR
			ENDIF
			WAIT CLEAR
		ENDIF
	ENDFOR		&&		move on to next area
	SET VIEW TO (Vw)		&&	Put things back together again.
	DELETE FILE (Vw+".VUE")		&&	delete the messy file.
ENDIF
CLEAR
@0,2 SAY "If you've enjoyed this"
@1,2 SAY "and would like to see"
@2,2 SAY "other FoxPro 2.0 Tools"
@3,2 SAY "(Some of which actually"
@4,2 SAY "do useful things),"
@5,2 SAY "send $25(US) to:"
@7,2 SAY "dbF Software Productions"
@8,2 SAY "P.O. Box 37194"
@9,2 SAY "Cleve., Ohio 44137-0194"
@10,2 SAY "CIS: 72117,165"
@11,2 SAY "(216)491-4581"
@13,3 SAY "Member ASP"
WAIT "We're done...tap any key" WINDOW
RELEASE WINDOW FERRET

RETURN
