FUNCTION Step
PARAMETER Vr, Stype, Mn, Mx, Stp, Fld
*	Vr		The name of the field to be stepped, not the name
*			of the field you're currently Validating
*	Stype	The type of Stepping you wish to do.
*			C = Character
*			Y = Year
*			M = Month
*			W = Week
*			D = Day
*			Anything else is whatever the Stp value is.
*
*	Mn		Minimum value for Dates and Numeric Steps.
*			Min is also the Position # (from left) of the
*			string you're modifying.  So, for example if you
*			are working on:      
*					         "ABCDE"
*
*			your Mn value would be 4, since the position held by
*			the "D" is the 4th from the left.
*
*	Mx		the Maximum value for Dates and Numeric Steps.
*
*	Stp		Step amount.  Usually 1, it tells the number to step by.
*			If you wanted to increment by 1/4, stp would be .25
*
*	Fld		Is this a Field you're Stepping on?  If so, send .T.


PRIVATE Nvr
NVr = &Vr.
DO CASE
CASE Stype $ "yY"		&&	Move a Year, for Date Stepping
	NVr = GOMONTH(Nvr,12*Stp)
CASE Stype $ "mM"		&&	Move a Month, for Date Stepping
	NVr = GOMONTH(Nvr,Stp)
CASE Stype $ "wW"		&&	Move a Week, for Date Stepping
	NVr = Nvr+7*Stp
CASE Stype $ "cC"		&&	Character Step
	NVr = STUFF(Nvr,Mn,1,CHR(ASC(SUBSTR(NVr,Mn,1))+1))
OTHERWISE
	NVr = Nvr+Stp
ENDCASE
IF !BETWEEN(Nvr, Mn, Mx)
	RETURN .F.
ENDIF
IF Fld
	REPLACE &Vr. WITH Nvr
ELSE
	&Vr. = Nvr
ENDIF
SHOW GETS
RETURN .T.
